import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public final class CommandLineParser {
    private CommandLineParser() {
        //not instantiable.
    }
    public static Map<String, List<String>> parse(String[] arguments) {
        Map<String, List<String>> result = new HashMap<String, List<String>>();
        String option = null;
        List<String> values = new ArrayList<String>();
        for (String argument : arguments) {
            if (option == null) {
                if (argument.startsWith("-")) {
                    option = argument.substring(1);
                    continue;
                } else {
                    throw new IllegalArgumentException(argument
                            + " is not a legal option");
                }
            }
            if (argument.startsWith("-")) {
                result.put(option, values);
                values = new ArrayList<String>();
                option = argument.substring(1);
            } else {
                values.add(argument);
            }
        }
        result.put(option, values);
        return result;
    }
}
