package algorithms;

import backend.Move;
import backend.RobotAlgorithmIF;
import backend.SensorGroup;
import backend.Sensor;

public class AWESOME_O implements RobotAlgorithmIF {

	//note to self: do not return null... ever
	
	int longSide = 0;
	int shortSide = 0;
	int man = 1;
	int moveCount = 0;
	int sideCount = 1;
	/**
	 * Used by captureSquare to keep track of moves left
	 */
	int step = 0;
	boolean start = true;
	int theSize = 0;
	boolean checking = true;
	int counter = 0;
	boolean startCounter = true;
	int turnCount = 0;
	
	
	public Move getMove(SensorGroup sensors) {
		turnCount++;
		// TODO Auto-generated method stub
		switch (man) {
		//First move - straight line
		case 1:
			if(start)
			{
				longSide = sensors.farSensorDistance() + 1;
				moveCount = (longSide - 1) / 2 + 2;
				start = false;
			}
			return march(sensors, Move.TURN_RIGHT);
			
	    //After turning right
		case 2:
			if (start)
			{
				shortSide = sensors.farSensorDistance() + 1;
				moveCount = shortSide - 1;
				start = false;
			}
			if (Sensor.BuildingOwner.ADVERSARY.equals(sensors.aheadRight().getOwner()))
                        {
			    man++;
                            return Move.TURN_RIGHT;
                        }
			return march(sensors, Move.TURN_RIGHT);
			
		//move forward 2 and turn right
		case 3:
			if (start) 
			{
				moveCount = 2;
				start = false;
			}
			
			return march(sensors, Move.TURN_RIGHT);
		
		//double back for capture
		case 4:
			if (start) {
				moveCount = shortSide - 1;
				start = false;
			}
			
			return march(sensors, Move.TURN_LEFT);
			
		//begin capturing bottom row
		case 5:
			return lCaptureSquare(sensors, 6);
		
		case 6:
			return rCaptureSquare(sensors, 6);
		
		default:
		return Move.SKIP;
		}	
	}

	/**
         * Sets a path a number of spaces equal to moveCount and moves forward that many times so long 
         * as there is enough street along the path. 
         * @param sensors Robot's sensors
         * @param finalMove The move to make once the distance has been traveled (i.e. turn left)
         * @return Move.AHEAD_WITH_CRUMBS or finalMove
	 */
        private Move march(SensorGroup sensors, Move finalMove) {
		if(moveCount > 0)
		{
			//might be trouble if you hit a building
			if (Sensor.CellType.STREET.equals(sensors.aheadOne().getCellType())) 
			{
				moveCount--;
				return Move.AHEAD_WITH_CRUMBS;
			}
			else moveCount = 0;
			
		}
		if (!(Sensor.CellType.STREET.equals(sensors.right().getCellType()))) {
			return Move.AHEAD_WITH_CRUMBS;
		}
		man++;
		start = true;
		return finalMove;
	}
	
	private Move lCaptureSquare(SensorGroup sensors, int size) {
		if(start)
		{
			theSize = size;
			start = false;
		}
		
//		if(startCounter)
//		{
//			counter = size;
//			startCounter = false;
//		}
//		
//		if(counter > 0)
//		{
//			counter --;
//			return Move.AHEAD_WITH_CRUMBS;
//		}
		
		if((sensors.aheadOne().getCellType().equals(Sensor.CellType.WALL) &&
				sensors.right().getCellType().equals(Sensor.CellType.WALL)) ||
				sensors.aheadLeft().getOwner().equals(Sensor.BuildingOwner.ADVERSARY))
		{
			theSize = size;
			return Move.TURN_LEFT;
		}
		
		if(checking)
		{
			if(sensors.aheadLeft().getOwner().equals(Sensor.BuildingOwner.ME) ||
					sensors.left().getOwner().equals(Sensor.BuildingOwner.ME))
			{
				if(turnCount>1500)/*(sensors.aheadRight().getOwner().equals(Sensor.BuildingOwner.ME) && 
						(!sensors.aheadLeft().getOwner().equals(Sensor.BuildingOwner.ME) ||
						sensors.left().getOwner().equals(Sensor.BuildingOwner.ME)))*/
				{
					
					man ++;
					return Move.TURN_RIGHT;
				}
				
				return Move.AHEAD_WITH_CRUMBS;
			}
			
			checking = false;
		}
		
		
		if(theSize > 0)
		{
			theSize --;
			return Move.AHEAD_WITH_CRUMBS;
		}
		
		start = true;
		checking = true;
		return Move.TURN_LEFT;
	}

	private Move rCaptureSquare(SensorGroup sensors, int size) {
		if(start)
		{
			theSize = size;
			start = false;
		}
		
		if((sensors.aheadOne().getCellType().equals(Sensor.CellType.WALL) &&
				sensors.right().getCellType().equals(Sensor.CellType.WALL)) ||
				sensors.aheadLeft().getOwner().equals(Sensor.BuildingOwner.ADVERSARY))
		{
			theSize = size;
			return Move.TURN_LEFT;
		}
		
		if(checking)
		{
			if(sensors.aheadRight().getOwner().equals(Sensor.BuildingOwner.ME) ||
					sensors.right().getOwner().equals(Sensor.BuildingOwner.ME))
			{
//				if(sensors.aheadRight().getOwner().equals(Sensor.BuildingOwner.ME))
//				{
//					man ++;
//					return Move.TURN_RIGHT;
//				}
				
				return Move.AHEAD_WITH_CRUMBS;
			}
			
			checking = false;
		}
		
		if(theSize > 0)
		{
			theSize --;
			return Move.AHEAD_WITH_CRUMBS;
		}
		
		start = true;
		checking = true;
		return Move.TURN_RIGHT;
	}
	
	public String getName() {
		// TODO Auto-generated method stub
		return "AWESOME-O";
	}

}
