

package algorithms;

import backend.Move;
import backend.RobotAlgorithmIF;
import backend.SensorGroup;

public class JoesBotTwo implements RobotAlgorithmIF {
	int buildingCounterL = 0; //count how many buildings you have passed Length Wise
	int buildingCounterW = 0; //count how many buildings you have passed Width wise
	int length = 7;		//initial Length of the first rectangle
	int width =18;			//initial width of the first rectangle
	int lengthCounter;		//counts how many buildings have been passed that are on the length
	int widthCounter;		//counts how many buildings have been passed that are on the width
	int turnCounter;		//counts the number of times you have turned right
	int defaultWidth = 7;	//sets a backup default width so that if the bot gets confused it will start making a 7w 9L rectangle
	int defaultLength = 9;  //sets a backup default length '' 		'''			''		''		''
	Move previousMove;		//sets the previous move
	int previousMoveCounter;//increments the counter of previous moves, so if the bot turns right too many times, it will start over at the defaul rectangle.
	int totalMoves = 0;
	Move nextMove = null;   //lets you set a move to make next
	Move futureMove = null; //lets you set a move to make in the future x turns from now, where x = futureMoveCountdown
	int futureMoveCountdown;
	public Move getMove(SensorGroup sensors) {
		totalMoves++;
		if(totalMoves < 721){//after the total moves is >= 721, it starts behaving signifcantly different, trying to get 1 square at a time.
			
			
			if(length == 0){ //if the length ever gets set to 0 by accident, it will automatically update back to a default of 3;
				length = 3;
				
			}
			if(width == 0){  //if the width ever gets set to 0, auto updates back to 3;
				width = 3;
				
			}
			if(sensors.aheadOne().getCellType().toString().equals("BUILDING")){ 
				//if a building is in front of you, you will turn to the left.
				turnCounter++;
				previousMove = Move.TURN_LEFT;
				return Move.TURN_LEFT;
			}
			
			if(previousMoveCounter > 6){
				length = defaultLength;  //if loop tests whether the bot has repeatedly turned right, and auto corrects it after 6 turns
				width = defaultWidth; 
				zeroBuildingCounterL();  //resets building counters to 0
				zeroBuildingCounterW();
				
				if(sensors.aheadOne().toString().equals("STREET")){  //only moves ahead with crumbs if there is a street, else turns until a street is in front of you
					previousMoveCounter = 0;  
					previousMove = Move.AHEAD_WITH_CRUMBS;
					return Move.AHEAD_WITH_CRUMBS;
				}
				
			}
			if(turnCounter%2 == 0){//if turn counter is divisible by two, you are going length wise, and then the rectangle adjusts to work on length
				
				if(sensors.aheadRight().getCellType().toString().equals("BUILDING") && sensors.aheadRight().getOwner().toString().equals("a building belonging to my adversary")){
					length = buildingCounterL;
					turnCounter++;
					zeroBuildingCounterL();
					if(previousMove == Move.TURN_RIGHT){
						previousMoveCounter++;
					}
					previousMove = Move.TURN_RIGHT;
					return Move.TURN_RIGHT;
				}
				if(sensors.right().getCellType().toString().equals("BUILDING") && sensors.right().getOwner().toString().equals("an unclaimed building")){
					incBuildingCounterL(); //increment Length building counter if the building on your right is owned.
				}
				if(buildingCounterL < length){ //as long as Lengthwise building counter is less than length, move ahead with crumbs
					if(sensors.aheadOne().getCellType().toString().equals("WALL")){ //if there is a wall in the way, you adapt your length to the number of buildings you've passed.
						turnCounter++; //increments number of turns made
						if(buildingCounterL > 0){
							length = buildingCounterL;
						}
						zeroBuildingCounterL(); //resets buildingcounter of Length to 0
						if(previousMove == Move.TURN_RIGHT){
							previousMoveCounter++; //adds one to previous move counter, if the moves are the same.
						}
						previousMove = Move.TURN_RIGHT;
						return Move.TURN_RIGHT;
						
					}
					previousMove = Move.AHEAD_WITH_CRUMBS;
					previousMoveCounter = 0;  //sets previous move counter to 0, since Move ahead with crumbs does not effect the move counter.
					return Move.AHEAD_WITH_CRUMBS;
				}
				else if(buildingCounterL == length && sensors.right().getCellType().toString().equals("BUILDING")){
					previousMove = Move.AHEAD_WITH_CRUMBS;
					previousMoveCounter = 0;
					return Move.AHEAD_WITH_CRUMBS;
				}
				else{
					zeroBuildingCounterL();
					turnCounter++;
					if(previousMove == Move.TURN_RIGHT){
						previousMoveCounter++;
					}
					
					return Move.TURN_RIGHT;
				}
			}
			else{  //symetrical(spelling?) to length section, only with widths instead
				if(sensors.aheadRight().getCellType().toString().equals("BUILDING") && sensors.aheadRight().getOwner().toString().equals("a building belonging to my adversary")){
					width = buildingCounterW;
					turnCounter++;
					zeroBuildingCounterW();
					if(previousMove == Move.TURN_RIGHT){
						previousMoveCounter++;
					}
					return Move.TURN_RIGHT;
				}
				if(sensors.right().getCellType().toString().equals("BUILDING") && sensors.right().getOwner().toString().equals("an unclaimed building")){
					incBuildingCounterW();
				}
				if(buildingCounterW < width){
					if(sensors.aheadOne().getCellType().toString().equals("WALL")){
						turnCounter++;
						if(buildingCounterW > 0){
							width = buildingCounterW;
						}
						zeroBuildingCounterL();
						if(previousMove == Move.TURN_RIGHT){
							previousMoveCounter++;
						}
						previousMove = Move.TURN_RIGHT;
						return Move.TURN_RIGHT;
						
					}
					previousMoveCounter = 0;
					return Move.AHEAD_WITH_CRUMBS;
				}
				else if(buildingCounterW == width && sensors.right().getCellType().toString().equals("BUILDING")){
					previousMoveCounter = 0;
					return Move.AHEAD_WITH_CRUMBS;
				}
				else{
					zeroBuildingCounterW();
					turnCounter++;
					if(previousMove == Move.TURN_RIGHT){
						previousMoveCounter++;
					}
					previousMove = Move.TURN_RIGHT;
					return Move.TURN_RIGHT;
				}
				
			}
		}
		else{//after 721 turns, attempts to capture individual squares instead of multples at once
			int test = 0; //useless, at this point
			if(nextMove != null){
				//returns the next move after setting it to null.  Next move has been set on the previous move
				Move temp_move = nextMove;
				nextMove=null;
				return temp_move;
			}
			
				
			
			/*if(sensors.right().getOwner().toString().equals("a building belonging to me")){
				if(test % 5 != 0){
					test++;
					return Move.AHEAD_WITH_CRUMBS;
				}
				else{
					test++;
					nextMove = Move.TURN_LEFT;
				}
				
				return Move.AHEAD_WITH_CRUMBS;
			}*/
			
			if(sensors.aheadOne().hasAdversary()){//skips turn if adversary is in the square in front 
				return Move.SKIP;
			}
			
			
			
			if(sensors.aheadOne().getCellType().toString().equals("WALL")){ //prevents from being stuck at a wall
				if(sensors.left().getCellType().toString().equals("WALL")){
					return Move.TURN_RIGHT;
				}
				return Move.TURN_LEFT;
			}
			if(sensors.left().getCellType().toString().equals("BUILDING") && sensors.left().getOwner().toString().equals("an unclaimed building")){
				nextMove = Move.TURN_LEFT;
			}
			if(sensors.right().getCellType().toString().equals("BUILDING")&& sensors.right().getOwner().toString().equals("an unclaimed building")){
				nextMove = Move.TURN_RIGHT;
			}
			
				
			return Move.AHEAD_WITH_CRUMBS;
		}
		
		
	}
	
	public void incBuildingCounterL(){//increments the building counter of Length
		buildingCounterL++;
	}
	public void incBuildingCounterW(){//increments the building counter of Width
		buildingCounterW++;
	}
	public void zeroBuildingCounterL(){//sets Building Counter of Length to zero
		buildingCounterL = 0;
	}
	public void zeroBuildingCounterW(){//sets Building Counter of Width to zero
		buildingCounterW = 0;
	}
	
	public String getName() {
		// TODO Auto-generated method stub
		return "Arthur and his Knights";
	}
	
}