package backend;

/**
 * This class represents a listener to be notified whenever a building cell
 * becomes captured.
 * 
 * @author Matthew Justin
 */
public interface BuildingCaptureListener {

    /**
     * Called when the specified cell has become captured.
     * 
     * @param cell The cell that was captured.
     */
    void fireBuildingChanged(BuildingCell cell);

}
