package backend;

/**
 * Algorithms and Compubility -- Project 2 (aka Kung Foo Robots) This interface
 * defines one location on the playing field.
 * 
 * @author Seth Sweep
 */
public interface Cell {
    /**
     * Returns true iff this cell is checked. Used by some algorithms in other
     * classes.
     * 
     * @return Whether this cell is checked.
     */
    public boolean isChecked();

    /**
     * Sets the checked value of this cell.
     */
    public void setChecked(boolean checked);

    /**
     * Returns true if this cell is an obstacle (i.e. a robot cannot pass
     * through it).
     * 
     * @return Whether this cell is an obstacle
     */
    public boolean isObstacle();

    /**
     * Returns the type of this cell (building, street, or wall).
     * 
     * @return The type of this cell.
     */
    public Sensor.CellType cellType();

    /**
     * Returns the message to be logged when a robot attempts to pass through
     * this cell when the cell is an obstacle.
     */
    public String getObstacleMessage();
}
