package backend;

/**
 * Algorithms and Compubility -- Project 2 (aka Kung Foo Robots).
 * 
 * A listener of the game, that when registered via the addListener() method of
 * GameLogic, will be notified when the game state has changed.  This includes
 * changes to the playing field, score, current move, and whether the game is
 * over.
 * 
 * @author Seth Sweep
 */
public interface GameListener {
    /**
     * Called when the game state has changed. This method is called to indicate
     * that only a given portion of the field has changed. Other details of the
     * game state may have changed as well (score, current move, game over).
     * 
     * @param x The leftmost x coordinate of the changed area.
     * @param y The topmost y coordinate of the changed area.
     * @param width The width of the changed area.
     * @param height The height of the changed area.
     */
    public void fireGameViewChanged(int x, int y, int width, int height);

    /**
     * Called when the game state has changed. When this method is called, an
     * unspecified portion of the field has changed. Other details of the game
     * state may have changed as well (score, current move, game over).
     */
    public void fireGameViewChanged();
}