package exceptions;

/**
 * Algorithms and Compubility -- Project 2 (aka Kung Foo Robots)
 * 
 * Exception which is thrown when there are too many players. This happens when
 * there isn't enough room on the borders of the playing field for all the
 * players.
 * 
 * @author Seth Sweep
 */
public class TooManyPlayersException extends IllegalArgumentException {

    /**
     * Constructs a new exception with the specified detail message.
     * 
     * @param message
     */
    public TooManyPlayersException(final String message) {
        super(message);
    }

    /**
     * Constructs a new exception.
     */
    public TooManyPlayersException() {
        super();
    }

    /**
     * Constructs a new exception with a detail message constructed based on the
     * number of players. The format of the message is:
     * 
     * The room dimensions are too small to initialize ## robots. Decrease the
     * number of robots or increase the room dimensions.
     * 
     * where ## is replaced by the value of players.
     * 
     * @param players The number of players.
     */
    public TooManyPlayersException(final int players) {
        this("The room dimensions are too small to initialize " + players
                + " robots.  Decrease the number of robots or "
                + "increase the room dimensions.");
    }
}
