package backend;

import static junit.framework.Assert.assertEquals;
import static junit.framework.Assert.assertTrue;
import robots.PredictableTestRobot;

public class MockListener implements GameListener {
	int lastTurn = 0;

	private PredictableTestRobot algorithm;

	private GameLogic logic;

	public MockListener(PredictableTestRobot algorithm, GameLogic logic) {
		this.algorithm = algorithm;
		this.logic = logic;
	}

	public void fireGameViewChanged(int x, int y, int width, int height) {
		fireGameViewChanged();
	}

	public void fireGameViewChanged() {
        int currentMove = logic.getCurrentTurn();
        String message = String
                .format(
                        "A turn went by where the listener wasn't notified; current move = %d; last move = %d",
                        currentMove, lastTurn);
        assertTrue(message, currentMove == lastTurn
                || currentMove == lastTurn + 1);
        lastTurn = logic.getCurrentTurn();
        assertEquals("The turn was incorrect",
                (algorithm.getMovesMade() == 0 ? 1 : algorithm.getMovesMade()),
                lastTurn);
    }

	public int getTurn() {
		return lastTurn;
	}

}
