package backend;

import java.util.Arrays;
import java.util.EnumSet;
import java.util.HashSet;

import junit.framework.TestCase;

/**
 * @author justnm
 */
public class MoveTest extends TestCase {

    private Move[] moves = new Move[] { Move.AHEAD_WITH_CRUMBS,
            Move.AHEAD_WITHOUT_CRUMBS, Move.SKIP, Move.TURN_LEFT,
            Move.TURN_RIGHT };

    public void testMoves() {
        assertEquals("The wrong moves were returned", new HashSet<Move>(Arrays
                .asList(moves)), EnumSet.allOf(Move.class));
    }

    public void testGetActionString() {
        final String[] expected = {
                "attempts to lay breadcrumbs and move ahead",
                "attempts to move ahead", "skips a turn", "turns left",
                "turns right" };
        for (int i = 0; i < moves.length; i++) {
            assertEquals("The wrong String was returned", expected[i], moves[i]
                    .getActionString());
        }
    }
}
