package backend;

import junit.framework.TestCase;

public class WallCellTest extends TestCase {
    WallCell instance = WallCell.getInstance();

    public void testGetInstance() {
        WallCell cell1 = WallCell.getInstance();
        WallCell cell2 = WallCell.getInstance();
        assertSame(
                "getInstance should have returned the same object both times",
                cell1, cell2);
    }

    public void testIsChecked() {
        assertTrue("A Wall should always returned that it's checked", instance
                .isChecked());
    }

    public void testIsObstacle() {
        assertTrue("A Wall should always returned that it's an obstacle",
                instance.isObstacle());
    }

    public void testSetChecked() {
        try {
            instance.setChecked(true);
            fail("An UnsupportedOperationException should have been thrown");
        } catch (UnsupportedOperationException e) {
            // this should happen.
        }
        assertTrue("A Wall should always returned that it's checked", instance
                .isChecked());

        try {
            instance.setChecked(false);
            fail("An UnsupportedOperationException should have been thrown");
        } catch (UnsupportedOperationException e) {
            // this should happen.
        }
        assertTrue("A Wall should always returned that it's checked", instance
                .isChecked());
    }

    public void testGetObstacleMessage() {
        assertEquals("The wrong obstacle message was returned",
                "Game Logic: Robot dines at the end of the universe.", instance
                        .getObstacleMessage());
    }
}
