package robots;

import junit.framework.Assert;
import backend.RobotAlgorithm;

/**
 * Algorithms and Compubility -- Project 2 (aka Kung Foo Robots)
 * 
 * This is a dummy implementation of the RobotAlgorithm used to test
 * the RobotAlgorithm abstract class.
 */
public class MockRobotAlgorithm extends RobotAlgorithm {
    private int _nextMove = SKIP;

    private String _toString = this.getClass().getSimpleName();

    private boolean sensorsSet = false;

    public String[] getSensorData() {
        return _sensorData;
    }

    public void setNextMove(int move) {
        _nextMove = move;
    }

    public void setToString(String string) {
        _toString = string;
    }

    public int getMove() {
        Assert.assertTrue(
                "The sensors should have been set before getMove() was called",
                sensorsSet);
        sensorsSet = false;
        return _nextMove;
    }

    public String toString() {
        return _toString;
    }

    @Override
    public void setSensors(String[] sensorData) {
        super.setSensors(sensorData);
        sensorsSet = true;
    }

}
