package robots;

import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import backend.Move;
import backend.RobotAlgorithmIF;
import backend.SensorGroup;

public class MoveListAlgorithm implements RobotAlgorithmIF {

    private Iterator<Move> _moveIterator;

    public MoveListAlgorithm(List<Move> moves) {
        _moveIterator = moves.iterator();
    }

    public MoveListAlgorithm(Move... moves) {
        this(Arrays.asList(moves));
    }

    public Move getMove(SensorGroup sensors) {
        if (_moveIterator.hasNext()) {
            return _moveIterator.next();
        } else {
            return Move.SKIP;
        }
    }

    public String getName() {
        return getClass().getSimpleName();
    }
}
