package robots;

import java.util.ArrayList;
import java.util.List;

import backend.Move;
import backend.RobotAlgorithmIF;
import backend.SensorGroup;

public class MoveRecorder implements RobotAlgorithmIF {

    RobotAlgorithmIF _algorithm;
    private List<Move> _moves = new ArrayList<Move>();
    
    public MoveRecorder(RobotAlgorithmIF algorithm) {
        _algorithm = algorithm;
    }
    
    public Move getMove(SensorGroup sensors) {
        Move move = _algorithm.getMove(sensors);
        _moves.add(move);
//        System.out.println(movesToString());
        return move;
    }

    public String getName() {
        return "Move Recorder for " + _algorithm.getName();
    }
    
    public List<Move> getMoves() {
        return _moves;
    }
    
    public String movesToString() {
        StringBuilder result = new StringBuilder();
        for (Move move : _moves) {
            result.append(move.name());
            result.append(", \n");
        }
        return result.toString();
    }
}
